/****************************************/
/* Library				*/
/****************************************/
#include <stdlib.h>
#include <stdio.h>
#include <math.h>


/****************************************/
/* GLOBAL VARIABLES SECTION		*/
/****************************************/
float Lo_D[20],Hi_D[20],Lo_R[20],Hi_R[20];

/****************************************/
/* CONSTANTS				*/
/****************************************/
#define max(x,y)  ( (x)>(y) ? (x) : (y) )
#define min(x,y)  ( (x)<(y) ? (x) : (y) )

#define CHARSIZE 200
#define WIN 5
#define lf 20


/****************************************/
/* STRCUTURE DEFINITION SECTION		*/
/****************************************/
typedef struct
{
	int state;
	int pos;
	int origin_state;
	int origin_pos;
	float score;
}TRACK;

typedef struct
{
	float *details;
	int *length;

}WAVE;

typedef struct
{
	float **approximations;
	float **details;

}WAVETYPE;

typedef struct
{
	float *approximation;
	float *details;

}DWTTYPE;


/****************************************/
/* Functions				*/
/****************************************/
float **GetIndexKey(char *,int *);
float **GetSignal(char *,float **a,int);
float *GetSingleIndexSignal(char *,int,float *);
float **SigWin(float **,int,int);
float **GetWave(float **,int,int);
float **GetSlope(float **,int,int);
float *SigWinSingle(float *,int);
float *GetWaveSingle(float *,int);
float *zscore(float *,int);
float *GetSlopeSingle(float *,int);
WAVE wavedec(float *,int,int,int *,int *);
WAVETYPE approximation(WAVE,int,int,int,int);
float *wrcoef_d(float *,int *,int,int);
float *wrcoef_a(float *,int *,int,int);
float *appcoef(float *,int *,int,int *,int);
float *idwt(float *,float *,int,int *,int,int);
float *upsaconv(float *,float *,int,int *,int);
float *wkeep_r(float *,int,int,int *);
float *detcoef(float *,int *,int,int,int *);
DWTTYPE dwt(float *,int *,int *);
float *dyaddown(float *,int);
float *wkeep(float *,int,int *,int);
float *conv2(float *,float *,int,int);
int *getSymIndices(int,int,int *);
float SquareEuclideanDistance(float *,float *,int);
float EuclideanDistance(float *, float *,int);

