/****************************************/
/* Library				*/
/****************************************/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "fasta.h"
#include "gamma.h"
#include "Domain_process.h"
#include "CentroidCluster.h"

/****************************************/
/* Constant				*/
/****************************************/
#define num_indices 3
#define DOMAIN_NUM 12	


/****************************************/
/* STRCUTURE DEFINITION SECTION		*/
/****************************************/
typedef struct
{
	float a;
	float b;
}GAMMATYPE;


/****************************************/
/* Global Variables			*/
/****************************************/
float ***d_centroid;
GAMMATYPE **d_gam;
int *d_len;
FILE *ftmp;

/****************************************/
/* Functions				*/
/****************************************/
void Initialize(void);
void TrainHMM(char *);
float *GetInitProb(int *,int,int);
float **GetTranProb(int *,int *,int,int,int);
float *GetEmitProb(int *,int,int);
GAMMATYPE FitDomainToGamma(float *,float **,int,int);
char *GetFilename(int,char *);





