#include "HMM_run.h"
FILE *falign;
void main(int argc, char **argv)
{
	int i,j,k;
	float ***test_sig;
	float score;
	FASTATYPE *test_seq;
	FILE *fresult,*ftmp;

	if (argc!=4)
	{printf("Usage: HMM_run <profile file> <test file> <result file>\n"); exit(0);}
	
	ReadProfile(argv[1]);	
	/* Print profiles */
	test_seq=fasta(argv[2],&GENE_NUM);
	test_sig=GetTestSignal(test_seq,argv[1]);

	if ((fresult=fopen(argv[3],"wt"))==NULL)
	{printf("Error: open %s\n",argv[3]); exit(0);}
	if ((falign=fopen("425align.txt","wt"))==NULL)
	{printf("Error: open 425align.txt\n"); exit(0);}
	
	for (i=0;i<GENE_NUM;i++)
	//for (i=0;i<1;i++)
	{
		score=Vertabi(test_sig[i],test_seq[i].seq_len);
		printf("%s\t%f\t%d\n",test_seq[i].name,score,test_seq[i].seq_len);
		//fprintf(fresult,"%s\t%f\t%d\n",test_seq[i].name,score,test_seq[i].seq_len);
		fprintf(fresult,"%f\n",score);
	}

	for(i=0;i<GENE_NUM;i++)	{for (j=0;j<INDEX_NUM;j++)	free(test_sig[i][j]);	free(test_sig[i]);}
	free(test_sig);
	for (i=0;i<GENE_NUM;i++)	{free(test_seq[i].seq);	free(test_seq[i].name);}
	free(test_seq);
	for (i=0;i<DOMAIN_NUM;i++)	free(d_gam[i]);		free(d_gam);
	for (i=0;i<DOMAIN_NUM;i++)	
	{for(j=0;j<num_indices;j++)	free(d_profile[i][j]);	free(d_profile[i]);}
	free(d_profile);	free(d_len);
	free(d_gap);
	for (i=0;i<DOMAIN_NUM-1;i++)	{free(d_insert[i]); free(d_insert_prob[i]);}
	free(d_insert);	free(d_insert_prob);
	fclose(falign);
}

/************************************************************************/
/* Function: ReadProfile(char *filename)				*/
/* Purpose: store profiles into d_profile[domain][profile_num][len]	*/
/************************************************************************/

void ReadProfile(char *filename)
{
	FILE *fid;
	int i,j,k;

	if ((fid=fopen(filename,"rt"))==NULL)
	{printf("Error: opening %s\n",filename);	exit(0);}

	fscanf(fid,"%d",&DOMAIN_NUM);
	if ((d_profile=(float ***)calloc(DOMAIN_NUM,sizeof(float **)))==NULL)
	{printf("Error:calloc to d_profile\n"); exit(0);}
	if ((d_gam=(GAMMATYPE **)calloc(DOMAIN_NUM,sizeof(GAMMATYPE **)))==NULL)
	{printf("Error:calloc to d_gam\n"); exit(0);}
	if ((d_len=(int *)calloc(DOMAIN_NUM,sizeof(int)))==NULL)
	{printf("Error:calloc to d_len\n"); exit(0);}
	for (i=0;i<DOMAIN_NUM;i++)
	{
		
		fscanf(fid,"%d",&d_len[i]);
		
		if ((d_profile[i]=(float **)calloc(num_indices,sizeof(float *)))==NULL)
		{printf("Error:calloc to d_profile\n"); exit(0);}
		if ((d_gam[i]=(GAMMATYPE *)calloc(num_indices,sizeof(GAMMATYPE)))==NULL)
		{printf("Error:calloc to d_gam\n"); exit(0);}

		for (j=0;j<num_indices;j++)
		{
			if ((d_profile[i][j]=(float *)calloc(d_len[i],sizeof(float)))==NULL)
			{printf("Error:calloc to d_profile\n"); exit(0);}
			for (k=0;k<d_len[i];k++)
				fscanf(fid,"%f",&d_profile[i][j][k]);
		}
		for (j=0;j<num_indices;j++)
		{
			fscanf(fid,"%f",&d_gam[i][j].a);
			fscanf(fid,"%f",&d_gam[i][j].b);
		}
	}

	fclose(fid);
	if ((d_insert=(int **)calloc(DOMAIN_NUM-1,sizeof(int *)))==NULL)
	{printf("Error calloc d_insert\n"); exit(0);}
	for (i=0;i<DOMAIN_NUM-1;i++)
		if ((d_insert[i]=(int *)calloc(5,sizeof(int)))==NULL)
		{printf("Error calloc d_insert[]\n"); exit(0);}

	// d_insert[domain][0] = frequency of zero insert between subdomains 
/*        d_insert[0][0]=204;    d_insert[1][0]=75;   d_insert[2][0]=251;   d_insert[3][0]=172;
        d_insert[4][0]=148;   d_insert[5][0]=297;   d_insert[6][0]=242;    d_insert[7][0]=21;
        d_insert[8][0]=120;    d_insert[9][0]=0;   d_insert[10][0]=158;
	
	// d_insert[domain][1] = frequency of having insert between subdomains 
        d_insert[0][1]=71;   d_insert[1][1]=28;   d_insert[2][1]=80;   d_insert[3][1]=77;   d_insert[4][1]=187;
	d_insert[5][1]=38;   d_insert[6][1]=86;   d_insert[7][1]=311;   d_insert[8][1]=200;   d_insert[9][1]=335;
	d_insert[10][1]=174;
	// d_insert[domain][2] = frequency of insert back to insert 
	d_insert[0][2]=346;         d_insert[1][2]=251;          d_insert[2][2]=58;         d_insert[3][2]=393;
	d_insert[4][2]=1095;         d_insert[5][2]=154;         d_insert[6][2]=476;        d_insert[7][2]=1520;
	d_insert[8][2]=224;        d_insert[9][2]=3485;        d_insert[10][2]=2617;
        // d_insert[domain][3] = frequency of having delete between subdomains 
        d_insert[0][3]=60;         d_insert[1][3]=232;          d_insert[2][3]=4;         d_insert[3][3]=86;
        d_insert[4][3]=0;         d_insert[5][3]=0;         d_insert[6][3]=7;        d_insert[7][3]=3;
        d_insert[8][3]=15;        d_insert[9][3]=0;        d_insert[10][3]=3;
        // d_insert[domain][4] = frequency of delete back to insert 
        d_insert[0][4]=31;         d_insert[1][4]=435;          d_insert[2][4]=1;         d_insert[3][4]=24;
        d_insert[4][4]=0;         d_insert[5][4]=0;         d_insert[6][4]=1;        d_insert[7][4]=2;
        d_insert[8][4]=0;        d_insert[9][4]=0;        d_insert[10][4]=0;
*/

	/* d_gap = distance state parameter */
	if ((d_gap=(int *)calloc(DOMAIN_NUM-1,sizeof(int)))==NULL)
	{printf("Error calloc to d_gap\n"); exit(0);}
      d_gap[0]=15;	d_gap[1]=27;	d_gap[2]=25;	d_gap[3]=34;	d_gap[4]=13;
	d_gap[5]=49;	d_gap[6]=27;	d_gap[7]=93;


	/* Calculate transition probability through frequency of occurence */
	if ((d_insert_prob=(float **)calloc(DOMAIN_NUM-1,sizeof(float *)))==NULL)
	{printf("Error calloc d_insert_prob\n"); exit(0);}
	for (i=0;i<DOMAIN_NUM-1;i++)
	       if ((d_insert_prob[i]=(float *)calloc(7,sizeof(float)))==NULL)
  	      {printf("Error calloc d_insert_prob[]\n"); exit(0);}
  
   /*     for (i=0;i<DOMAIN_NUM-1;i++)
        {
		if (d_insert[i][0]!=0)
	                d_insert_prob[i][0]=-log((float)d_insert[i][0]/(d_insert[i][0]+d_insert[i][1]+d_insert[i][3]));
		else
			d_insert_prob[i][0]=1000.;
		if (d_insert[i][1]!=0)
	                d_insert_prob[i][1]=-log((float)d_insert[i][1]/(d_insert[i][0]+d_insert[i][1]+d_insert[i][3]));
		else
			d_insert_prob[i][1]=1000.;
		if (d_insert[i][2]+d_insert[i][1]!=0)
		{
	                d_insert_prob[i][2]=-log((float)d_insert[i][2]/(d_insert[i][1]+d_insert[i][2]));
			d_insert_prob[i][5]=-log(1.-(float)d_insert[i][2]/(d_insert[i][1]+d_insert[i][2]));
		}
		else
		{
			d_insert_prob[i][2]=1000.;
			d_insert_prob[i][5]=1000.;
		}
		if (d_insert[i][3]!=0)
	                d_insert_prob[i][3]=-log((float)d_insert[i][3]/(d_insert[i][0]+d_insert[i][1]+d_insert[i][3]));
		else
			 d_insert_prob[i][3]=1000.;
		if (d_insert[i][4]+d_insert[i][3]!=0)
		{
	                d_insert_prob[i][4]=-log((float)d_insert[i][3]/(d_insert[i][3]+d_insert[i][4]));
			d_insert_prob[i][6]=-log(1.-(float)d_insert[i][3]/(d_insert[i][3]+d_insert[i][4]));
		}
		else
		{
			d_insert_prob[i][4]=1000.;
			d_insert_prob[i][6]=1000.;
		}
	}	
	*/
}

/************************************************************************/
/* Function: float ***GetTestSignal(FASTATYPE *seq)				*/
/* Purpose: Read test set and store in seq_sig	*/
/************************************************************************/
float ***GetTestSignal(FASTATYPE *seq,char *mainname)
{
	int i,j,k;
	float **aa_index,***sig;
	char filename[100];
	
	strcpy(filename,mainname);
	strcat(filename,".out");	
	aa_index=GetIndexKey(filename,&INDEX_NUM);

	if ((sig=(float ***)calloc(GENE_NUM,sizeof(float **)))==NULL)
	{printf("Error calloc sig\n"); exit(0);}

	for (i=0;i<GENE_NUM;i++)
		sig[i]=GetSignal(seq[i].seq,aa_index,INDEX_NUM);

	for (i=0;i<INDEX_NUM;i++)	free(aa_index[i]);	free(aa_index);

	return sig;
}

/************************************************************************/
/* Function: Vertabi(float **test_sig,int seq_len)			*/
/* Purpose: Get score of input test_signal				*/
/************************************************************************/
float Vertabi(float **test_sig,int seq_len)
{
	int i,j,k,select,num_insert,sum_len=0;
	float dist1,dist2;
	float score=0.,prob_tmp,prob_tmp1;
	float *sig,*wave,*wave_slope,*win,*sig_z;
	float dist;
	TRACKTYPE **prob_matrix;
	int index_i;


	if ((prob_matrix=(TRACKTYPE **)calloc(DOMAIN_NUM,sizeof(TRACKTYPE *)))==NULL)
	{printf("Error: calloc to prob_matrix\n"); exit(0);}

	
	for (i=0;i<DOMAIN_NUM;i++)
	{

		if ((prob_matrix[i]=(TRACKTYPE *)calloc(seq_len,sizeof(TRACKTYPE)))==NULL)	
		{printf("Error: calloc to prob_matrix\n"); exit(0);}
		for (j=0;j<seq_len;j++)	{prob_matrix[i][j].prob=1000.;	prob_matrix[i][j].pos=0; prob_matrix[i][j].score=1000.;}
		
		for (j=0;j<seq_len-d_len[i];j++)
		{
			prob_tmp=0.;
			for (index_i=0;index_i<num_indices;index_i++)
			{
			
			if ((sig=(float *)calloc(d_len[i],sizeof(float)))==NULL)
			{printf("Error: calloc to sig\n"); exit(0);}
			for (k=0;k<d_len[i];k++)
			{
				sig[k]=test_sig[num_indices*i+index_i][j+k];
				
			}
			win=SigWinSingle(sig,d_len[i]);
			wave=GetWaveSingle(win,d_len[i]);
			wave_slope=GetSlopeSingle(wave,d_len[i]);
			/*if (i==0 && j==508)
			{	for (k=0;k<d_len[i];k++)	printf("%f\t",wave_slope[k]);
				printf("\n");
			}*/

/*			if (i==0 && index_i==0 && j==56)
				for (k=0;k<d_len[i];k++)
					fprintf(falign,"%f\t",wave[k]);
			else if (i==1 && index_i==0 && j==80)
                                for (k=0;k<d_len[i];k++)
                                        fprintf(falign,"%f\t",wave[k]);
                        else if (i==2 && index_i==0 && j==98)
                                for (k=0;k<d_len[i];k++)
                                        fprintf(falign,"%f\t",wave[k]);
                        else if (i==3 && index_i==0 && j==113)
                                for (k=0;k<d_len[i];k++)
                                        fprintf(falign,"%f\t",wave[k]);
                        else if (i==4 && index_i==0 && j==127)
                                for (k=0;k<d_len[i];k++)
                                        fprintf(falign,"%f\t",wave[k]);
                        else if (i==5 && index_i==0 && j==152)
                                for (k=0;k<d_len[i];k++)
                                        fprintf(falign,"%f\t",wave[k]);
                        else if (i==6 && index_i==0 && j==175)
                                for (k=0;k<d_len[i];k++)
                                        fprintf(falign,"%f\t",wave[k]);
                        else if (i==7 && index_i==0 && j==193)
                                for (k=0;k<d_len[i];k++)
                                        fprintf(falign,"%f\t",wave[k]);
                        else if (i==8 && index_i==0 && j==211)
                                for (k=0;k<d_len[i];k++)
                                        fprintf(falign,"%f\t",wave[k]);
                        else if (i==9 && index_i==0 && j==229)
                                for (k=0;k<d_len[i];k++)
                                        fprintf(falign,"%f\t",wave[k]);
                        else if (i==10 && index_i==0 && j==260)
                                for (k=0;k<d_len[i];k++)
                                        fprintf(falign,"%f\t",wave[k]);
                        else if (i==11 && index_i==0 && j==280)
                                for (k=0;k<d_len[i];k++)
                                        fprintf(falign,"%f\t",wave[k]);
			if (index_i==0)	fprintf(falign,"\n");
*/


//			dist=SquareEuclideanDistance(wave_slope,d_profile[i][index_i],d_len[i]);
			dist=EuclideanDistance(wave_slope,d_profile[i][index_i],d_len[i]);
			
			if (index_i==0)	dist1=dist;
			else dist2=dist;
			prob_tmp+=-log(gampdf(dist,d_gam[i][index_i].a,d_gam[i][index_i].b));
			free(sig);	free(win);	free(wave);	free(wave_slope);
			}//end index_i
			prob_tmp1=prob_tmp;
			if (i>0)	sum_len+=d_len[i-1];
			if (i!=0)
			{
				//for (k=0;k<max(0,j-d_len[i-1]+5);k++)
				for (k=max(0,j-d_len[i-1]-d_gap[i-1]);k<max(0,j-d_len[i-1]);k++)
				{
					
					/*num_insert=j-k-d_len[i-1]-d_gap[i-1];
					if (num_insert==0)
						prob_tmp=prob_tmp1+d_insert_prob[i-1][0];
					else if (num_insert>0)
						prob_tmp=prob_tmp1+d_insert_prob[i-1][1]+d_insert_prob[i-1][2]*(abs(num_insert)-1);
					else if (num_insert<0)
						prob_tmp=prob_tmp1+d_insert_prob[i-1][3]+d_insert_prob[i-1][4]*(abs(num_insert)-1);
					*/
										
					if (prob_matrix[i][j].prob>prob_tmp+prob_matrix[i-1][k].prob)
					{
						prob_matrix[i][j].prob=prob_tmp+prob_matrix[i-1][k].prob;
						prob_matrix[i][j].score=prob_tmp;
						prob_matrix[i][j].pos=k;
						//prob_matrix[i][j].dist1=dist1;
						//prob_matrix[i][j].dist2=dist2;
					}
				}
			}
			else
			{
				prob_matrix[i][j].prob=prob_tmp;
				//prob_matrix[i][j].dist1=dist1;
				//prob_matrix[i][j].dist2=dist2;
				prob_matrix[i][j].score=prob_tmp;
			}
		}		
	}

	score=1000.;
	for (i=0;i<seq_len;i++)
		if (score>prob_matrix[DOMAIN_NUM-1][i].prob)
		{
			score=prob_matrix[DOMAIN_NUM-1][i].prob;
			select=i;
		}
	
	i=DOMAIN_NUM-1;

	//fprintf(falign,"%d\t",select);

	while (i!=0)
	{
		printf("prob_matrix[%d][%d]=%f(%f,%f)\t%f\n",i,select,prob_matrix[i][select].prob,
				prob_matrix[i][select].dist1,prob_matrix[i][select].dist2,prob_matrix[i][select].score);
		//fprintf(falign,"%d\t",prob_matrix[i][select].pos);
		select=prob_matrix[i][select].pos;
		i--;
	}
	
	printf("prob_matrix[%d][%d]=%f(%f,%f)\t%f\n",i,select,prob_matrix[i][select].prob,
                             prob_matrix[i][select].dist1,prob_matrix[i][select].dist2,prob_matrix[i][select].score);
	
	//fprintf(falign,"\n");

	for (i=0;i<DOMAIN_NUM;i++)	free(prob_matrix[i]);	free(prob_matrix);

	return score;
}



